#ifndef _Number_h_
#define _Number_h_

/**
 * Abstract base class 'Number'
 */

///  'Number' is abstract (no objects can be created) 
class Number
{
 public:
  /// default constructor
  Number();

  /// copy constructor
  Number(const Number &other);

  /// destructor
  virtual ~Number();
       
  /// read value from 'cin' (abstract method) 
  virtual void read() = 0;

  /// write value to 'cout' (abstract method; object is not changed)
  virtual void write() const = 0;

  /// return number of instances (static member function)
  static int noOfNumbers();   
  
  private:

  /// number of instances (static var: only one instance for the whole class)
  static int count;  
};

#endif
